/* Tabela VENDEDOR*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela VENDEDOR */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela VENDEDOR, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_EXP_VENDEDOR
AFTER DELETE OR INSERT OR UPDATE
ON VENDEDOR FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN

         IF :NEW.CDVENDEDOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Vendedor = ' || NVL(:NEW.CDVENDEDOR,'') || ' ';
         END IF;
         IF :NEW.IDTPIJURVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de inscio jurdica = ' || NVL(:NEW.IDTPIJURVEN,'') || ' ';
         END IF;
         IF :NEW.NRINSJURVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Inscrio jurdica = ' || NVL(:NEW.NRINSJURVEN,'') || ' ';
         END IF;
         IF :NEW.NMRAZSOCVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Razo social = ' || NVL(:NEW.NMRAZSOCVEN,'') || ' ';
         END IF;
         IF :NEW.NMFANVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Nome fantasia = ' || NVL(:NEW.NMFANVEN,'') || ' ';
         END IF;
         IF :NEW.DTNASCVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Data de nascimento = ' || NVL(:NEW.DTNASCVEN,'') || ' ';
         END IF;
         IF :NEW.VRPECOMVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso = ' || NVL(:NEW.VRPECOMVEN,'') || '% ';
         END IF;
         IF :NEW.VRPEMAXDESVE IS NOT NULL THEN
            V_DESC := V_DESC || 'Desconto mximo = ' || NVL(:NEW.VRPEMAXDESVE,'') || '% ';
         END IF;
         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Operador = ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;
         IF :NEW.CDFORNECED IS NOT NULL THEN
            V_DESC := V_DESC || 'Fornecedor = ' || NVL(:NEW.CDFORNECED,'') || ' ';
         END IF;
         IF :NEW.CDCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de comisso = ' || NVL(:NEW.CDCOMISSAO,'') || ' ';
         END IF;
         IF :NEW.IDLIGEXTVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Realiza ligaes externas = ' || NVL(:NEW.IDLIGEXTVEND,'') || ' ';
         END IF;
         IF :NEW.CDPRECOBASE IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de preo = ' || NVL(:NEW.CDPRECOBASE,'') || ' ';
         END IF;
         IF :NEW.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Setor = ' || NVL(:NEW.CDSETOR,'') || ' ';
         END IF;
         IF :NEW.DTULTATUVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima alterao = ' || NVL(:NEW.DTULTATUVEND,'') || ' ';
         END IF;
         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;
         IF :NEW.CDCAIXA IS NOT NULL THEN
            V_DESC := V_DESC || 'Caixa = ' || NVL(:NEW.CDCAIXA,'') || ' ';
         END IF;
         IF :NEW.SGVENDORCEVE IS NOT NULL THEN
            V_DESC := V_DESC || 'Sigla = ' || NVL(:NEW.SGVENDORCEVE,'') || ' ';
         END IF;
         IF :NEW.VRAPROVAUTOORC IS NOT NULL THEN
            V_DESC := V_DESC || 'Aprovao automtica = ' || NVL(:NEW.VRAPROVAUTOORC,'') || ' ';
         END IF;
         IF :NEW.CDMARKUP IS NOT NULL THEN
            V_DESC := V_DESC || 'Markup = ' || NVL(:NEW.CDMARKUP,'') || ' ';
         END IF;
         IF :NEW.DSPLACAVEICULO IS NOT NULL THEN
            V_DESC := V_DESC || 'Placa motoboy = ' || NVL(:NEW.DSPLACAVEICULO,'') || ' ';
         END IF;
         IF :NEW.VRCOMPROVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso preo promocional = ' || NVL(:NEW.VRCOMPROVEND,'') || '% ';
         END IF;
         IF :NEW.CDCOMISSAOPROMO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de comisso p/ promoo = ' || NVL(:NEW.CDCOMISSAOPROMO,'') || ' ';
         END IF;
         IF :NEW.IDGERACOMISVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera comisso = ' || NVL(:NEW.IDGERACOMISVEND,'') || ' ';
         END IF;
         IF :NEW.IDCARGOVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Cargo = ' || NVL(:NEW.IDCARGOVEND,'') || ' ';
         END IF;
         IF :NEW.CDVENDEDORSUP IS NOT NULL THEN
            V_DESC := V_DESC || 'Surpevisor = ' || NVL(:NEW.CDVENDEDORSUP,'') || ' ';
         END IF;
         IF :NEW.NRPARCNEGOCIO IS NOT NULL THEN
            V_DESC := V_DESC || 'Parceiro de negocio = ' || NVL(:NEW.NRPARCNEGOCIO,'') || ' ';
         END IF;
         IF :NEW.CDVENDEDORGER IS NOT NULL THEN
            V_DESC := V_DESC || 'Gerente = ' || NVL(:NEW.CDVENDEDORGER,'') || ' ';
         END IF;
         IF :NEW.CDVENDEDORAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'Auxiliar = ' || NVL(:NEW.CDVENDEDORAUX,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDVENDEDOR;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDVENDEDOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Vendedor = ' || NVL(:NEW.CDVENDEDOR,'') || ' ';
         END IF;
         IF :NEW.IDTPIJURVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de inscio jurdica = ' || NVL(:NEW.IDTPIJURVEN,'') || ' ';
         END IF;
         IF :NEW.NRINSJURVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Inscrio jurdica = ' || NVL(:NEW.NRINSJURVEN,'') || ' ';
         END IF;
         IF :NEW.NMRAZSOCVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Razo social = ' || NVL(:NEW.NMRAZSOCVEN,'') || ' ';
         END IF;
         IF :NEW.NMFANVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Nome fantasia = ' || NVL(:NEW.NMFANVEN,'') || ' ';
         END IF;
         IF :NEW.DTNASCVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Data de nascimento = ' || NVL(:NEW.DTNASCVEN,'') || ' ';
         END IF;
         IF :NEW.VRPECOMVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso = ' || NVL(:NEW.VRPECOMVEN,'') || '% ';
         END IF;
         IF :NEW.VRPEMAXDESVE IS NOT NULL THEN
            V_DESC := V_DESC || 'Desconto mximo = ' || NVL(:NEW.VRPEMAXDESVE,'') || '% ';
         END IF;
         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Operador = ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;
         IF :NEW.CDFORNECED IS NOT NULL THEN
            V_DESC := V_DESC || 'Fornecedor = ' || NVL(:NEW.CDFORNECED,'') || ' ';
         END IF;
         IF :NEW.CDCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de comisso = ' || NVL(:NEW.CDCOMISSAO,'') || ' ';
         END IF;
         IF :NEW.IDLIGEXTVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Realiza ligaes externas = ' || NVL(:NEW.IDLIGEXTVEND,'') || ' ';
         END IF;
         IF :NEW.CDPRECOBASE IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de preo = ' || NVL(:NEW.CDPRECOBASE,'') || ' ';
         END IF;
         IF :NEW.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Setor = ' || NVL(:NEW.CDSETOR,'') || ' ';
         END IF;
         IF :NEW.DTULTATUVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima alterao = ' || NVL(:NEW.DTULTATUVEND,'') || ' ';
         END IF;
         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;
         IF :NEW.CDCAIXA IS NOT NULL THEN
            V_DESC := V_DESC || 'Caixa = ' || NVL(:NEW.CDCAIXA,'') || ' ';
         END IF;
         IF :NEW.SGVENDORCEVE IS NOT NULL THEN
            V_DESC := V_DESC || 'Sigla = ' || NVL(:NEW.SGVENDORCEVE,'') || ' ';
         END IF;
         IF :NEW.VRAPROVAUTOORC IS NOT NULL THEN
            V_DESC := V_DESC || 'Aprovao automtica = ' || NVL(:NEW.VRAPROVAUTOORC,'') || ' ';
         END IF;
         IF :NEW.CDMARKUP IS NOT NULL THEN
            V_DESC := V_DESC || 'Markup = ' || NVL(:NEW.CDMARKUP,'') || ' ';
         END IF;
         IF :NEW.DSPLACAVEICULO IS NOT NULL THEN
            V_DESC := V_DESC || 'Placa motoboy = ' || NVL(:NEW.DSPLACAVEICULO,'') || ' ';
         END IF;
         IF :NEW.VRCOMPROVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso preo promocional = ' || NVL(:NEW.VRCOMPROVEND,'') || '% ';
         END IF;
         IF :NEW.CDCOMISSAOPROMO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de comisso p/ promoo = ' || NVL(:NEW.CDCOMISSAOPROMO,'') || ' ';
         END IF;
         IF :NEW.IDGERACOMISVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera comisso = ' || NVL(:NEW.IDGERACOMISVEND,'') || ' ';
         END IF;
         IF :NEW.IDCARGOVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Cargo = ' || NVL(:NEW.IDCARGOVEND,'') || ' ';
         END IF;
         IF :NEW.CDVENDEDORSUP IS NOT NULL THEN
            V_DESC := V_DESC || 'Surpevisor = ' || NVL(:NEW.CDVENDEDORSUP,'') || ' ';
         END IF;
         IF :NEW.NRPARCNEGOCIO IS NOT NULL THEN
            V_DESC := V_DESC || 'Parceiro de negocio = ' || NVL(:NEW.NRPARCNEGOCIO,'') || ' ';
         END IF;
         IF :NEW.CDVENDEDORGER IS NOT NULL THEN
            V_DESC := V_DESC || 'Gerente = ' || NVL(:NEW.CDVENDEDORGER,'') || ' ';
         END IF;
         IF :NEW.CDVENDEDORAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'Auxiliar = ' || NVL(:NEW.CDVENDEDORAUX,'') || ' ';
         END IF;           

         V_ITPESQ     := :NEW.CDVENDEDOR;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDVENDEDOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Vendedor = ' || NVL(:OLD.CDVENDEDOR,'') || ' ';
         END IF;
         IF :OLD.IDTPIJURVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de inscio jurdica = ' || NVL(:OLD.IDTPIJURVEN,'') || ' ';
         END IF;
         IF :OLD.NRINSJURVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Inscrio jurdica = ' || NVL(:OLD.NRINSJURVEN,'') || ' ';
         END IF;
         IF :OLD.NMRAZSOCVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Razo social = ' || NVL(:OLD.NMRAZSOCVEN,'') || ' ';
         END IF;
         IF :OLD.NMFANVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Nome fantasia = ' || NVL(:OLD.NMFANVEN,'') || ' ';
         END IF;
         IF :OLD.DTNASCVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Data de nascimento = ' || NVL(:OLD.DTNASCVEN,'') || ' ';
         END IF;
         IF :OLD.VRPECOMVEN IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso = ' || NVL(:OLD.VRPECOMVEN,'') || '% ';
         END IF;
         IF :OLD.VRPEMAXDESVE IS NOT NULL THEN
            V_DESC := V_DESC || 'Desconto mximo = ' || NVL(:OLD.VRPEMAXDESVE,'') || '% ';
         END IF;
         IF :OLD.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Operador = ' || NVL(:OLD.CDOPERADOR,'') || ' ';
         END IF;
         IF :OLD.CDFORNECED IS NOT NULL THEN
            V_DESC := V_DESC || 'Fornecedor = ' || NVL(:OLD.CDFORNECED,'') || ' ';
         END IF;
         IF :OLD.CDCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de comisso = ' || NVL(:OLD.CDCOMISSAO,'') || ' ';
         END IF;
         IF :OLD.IDLIGEXTVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Realiza ligaes externas = ' || NVL(:OLD.IDLIGEXTVEND,'') || ' ';
         END IF;
         IF :OLD.CDPRECOBASE IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de preo = ' || NVL(:OLD.CDPRECOBASE,'') || ' ';
         END IF;
         IF :OLD.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Setor = ' || NVL(:OLD.CDSETOR,'') || ' ';
         END IF;
         IF :OLD.DTULTATUVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima alterao = ' || NVL(:OLD.DTULTATUVEND,'') || ' ';
         END IF;
         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:OLD.CDFILIAL,'') || ' ';
         END IF;
         IF :OLD.CDCAIXA IS NOT NULL THEN
            V_DESC := V_DESC || 'Caixa = ' || NVL(:OLD.CDCAIXA,'') || ' ';
         END IF;
         IF :OLD.SGVENDORCEVE IS NOT NULL THEN
            V_DESC := V_DESC || 'Sigla = ' || NVL(:OLD.SGVENDORCEVE,'') || ' ';
         END IF;
         IF :OLD.VRAPROVAUTOORC IS NOT NULL THEN
            V_DESC := V_DESC || 'Aprovao automtica = ' || NVL(:OLD.VRAPROVAUTOORC,'') || ' ';
         END IF;
         IF :OLD.CDMARKUP IS NOT NULL THEN
            V_DESC := V_DESC || 'Markup = ' || NVL(:OLD.CDMARKUP,'') || ' ';
         END IF;
         IF :OLD.DSPLACAVEICULO IS NOT NULL THEN
            V_DESC := V_DESC || 'Placa motoboy = ' || NVL(:OLD.DSPLACAVEICULO,'') || ' ';
         END IF;
         IF :OLD.VRCOMPROVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso preo promocional = ' || NVL(:OLD.VRCOMPROVEND,'') || '% ';
         END IF;
         IF :OLD.CDCOMISSAOPROMO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de comisso p/ promoo = ' || NVL(:OLD.CDCOMISSAOPROMO,'') || ' ';
         END IF;
         IF :OLD.IDGERACOMISVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera comisso = ' || NVL(:OLD.IDGERACOMISVEND,'') || ' ';
         END IF;
         IF :OLD.IDCARGOVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Cargo = ' || NVL(:OLD.IDCARGOVEND,'') || ' ';
         END IF;
         IF :OLD.CDVENDEDORSUP IS NOT NULL THEN
            V_DESC := V_DESC || 'Surpevisor = ' || NVL(:OLD.CDVENDEDORSUP,'') || ' ';
         END IF;
         IF :OLD.NRPARCNEGOCIO IS NOT NULL THEN
            V_DESC := V_DESC || 'Parceiro de negocio = ' || NVL(:OLD.NRPARCNEGOCIO,'') || ' ';
         END IF;
         IF :OLD.CDVENDEDORGER IS NOT NULL THEN
            V_DESC := V_DESC || 'Gerente = ' || NVL(:OLD.CDVENDEDORGER,'') || ' ';
         END IF;
         IF :OLD.CDVENDEDORAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'Auxiliar = ' || NVL(:OLD.CDVENDEDORAUX,'') || ' ';
         END IF;            

         V_ITPESQ     := :OLD.CDVENDEDOR;
         V_IDTIPOOPER := '3';

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('VENDEDOR', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_EXP_VENDEDOR','5.85.xxx'); END;
/